import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["component"],
    _excluded2 = ["labelText", "disabled", "input", "options", "FormGroupProps", "helperText", "meta", "validateOnMount"];
import React from 'react';
import PropTypes from 'prop-types';
import useFieldApi from "@data-driven-forms/react-form-renderer/use-field-api";
import { FormGroup, RadioButtonGroup, RadioButton } from 'carbon-components-react';
import prepareProps from '../prepare-props';
import HelperTextBlock from '../helper-text-block/helper-text-block';

var Radio = function Radio(_ref) {
  var component = _ref.component,
      props = _objectWithoutProperties(_ref, _excluded);

  var _useFieldApi = useFieldApi(prepareProps(props)),
      labelText = _useFieldApi.labelText,
      disabled = _useFieldApi.disabled,
      input = _useFieldApi.input,
      options = _useFieldApi.options,
      FormGroupProps = _useFieldApi.FormGroupProps,
      helperText = _useFieldApi.helperText,
      meta = _useFieldApi.meta,
      validateOnMount = _useFieldApi.validateOnMount,
      rest = _objectWithoutProperties(_useFieldApi, _excluded2);

  var invalid = (meta.touched || validateOnMount) && (meta.error || meta.submitError);
  var warnText = (meta.touched || validateOnMount) && meta.warning;
  return /*#__PURE__*/React.createElement(FormGroup, _extends({
    legendText: labelText
  }, FormGroupProps), /*#__PURE__*/React.createElement(RadioButtonGroup, _extends({}, input, {
    valueSelected: input.value,
    disabled: disabled
  }, rest), options.map(function (option) {
    return /*#__PURE__*/React.createElement(RadioButton, _extends({
      key: option.value,
      disabled: disabled,
      labelText: option.label,
      value: option.value
    }, option));
  })), /*#__PURE__*/React.createElement(HelperTextBlock, {
    helperText: helperText,
    errorText: invalid,
    warnText: warnText
  }));
};

Radio.propTypes = {
  component: PropTypes.string,
  FormGroupProps: PropTypes.object,
  isDisabled: PropTypes.bool,
  label: PropTypes.node,
  isRequired: PropTypes.bool,
  options: PropTypes.arrayOf(PropTypes.shape({
    label: PropTypes.node,
    value: PropTypes.oneOfType([PropTypes.string, PropTypes.number])
  }))
};
export default Radio;