"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.Title = exports.Header = exports.Form = exports.Description = exports.ButtonGroup = exports.Button = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _clsx = _interopRequireDefault(require("clsx"));

var _reactJssCjs = require("react-jss/dist/react-jss.cjs.js");

var _carbonComponentsReact = require("carbon-components-react");

var _formTemplate = _interopRequireDefault(require("@data-driven-forms/common/form-template"));

var _excluded = ["label", "buttonType"],
    _excluded2 = ["children", "className"],
    _excluded3 = ["children"],
    _excluded4 = ["children"],
    _excluded5 = ["children", "className"];
var useStyles = (0, _reactJssCjs.createUseStyles)({
  buttons: {
    marginTop: 48
  },
  header: {
    marginBottom: 40,
    div: {
      marginTop: 8
    }
  },
  form: {
    '&>:not(:last-child)': {
      marginBottom: 32
    }
  }
});

var Button = function Button(_ref) {
  var label = _ref.label,
      buttonType = _ref.buttonType,
      props = (0, _objectWithoutProperties2["default"])(_ref, _excluded);
  return /*#__PURE__*/_react["default"].createElement(_carbonComponentsReact.Button, (0, _extends2["default"])({
    kind: buttonType === 'submit' ? 'primary' : 'secondary'
  }, props), label);
};

exports.Button = Button;
Button.propTypes = {
  label: _propTypes["default"].oneOfType([_propTypes["default"].arrayOf(_propTypes["default"].node), _propTypes["default"].node]),
  buttonType: _propTypes["default"].string
};

var ButtonGroup = function ButtonGroup(_ref2) {
  var children = _ref2.children,
      className = _ref2.className,
      props = (0, _objectWithoutProperties2["default"])(_ref2, _excluded2);

  var _useStyles = useStyles(),
      butttons = _useStyles.butttons;

  return /*#__PURE__*/_react["default"].createElement(_carbonComponentsReact.ButtonSet, (0, _extends2["default"])({}, props, {
    className: (0, _clsx["default"])(butttons, className)
  }), children);
};

exports.ButtonGroup = ButtonGroup;
ButtonGroup.propTypes = {
  children: _propTypes["default"].oneOfType([_propTypes["default"].arrayOf(_propTypes["default"].node), _propTypes["default"].node]),
  className: _propTypes["default"].string
};

var Title = function Title(_ref3) {
  var children = _ref3.children,
      props = (0, _objectWithoutProperties2["default"])(_ref3, _excluded3);
  return /*#__PURE__*/_react["default"].createElement("h3", props, children);
};

exports.Title = Title;
Title.propTypes = {
  children: _propTypes["default"].oneOfType([_propTypes["default"].arrayOf(_propTypes["default"].node), _propTypes["default"].node])
};

var Description = function Description(_ref4) {
  var children = _ref4.children,
      props = (0, _objectWithoutProperties2["default"])(_ref4, _excluded4);
  return /*#__PURE__*/_react["default"].createElement("div", props, children);
};

exports.Description = Description;
Description.propTypes = {
  children: _propTypes["default"].oneOfType([_propTypes["default"].arrayOf(_propTypes["default"].node), _propTypes["default"].node])
};

var Form = function Form(_ref5) {
  var children = _ref5.children,
      className = _ref5.className,
      props = (0, _objectWithoutProperties2["default"])(_ref5, _excluded5);

  var _useStyles2 = useStyles(),
      form = _useStyles2.form;

  return /*#__PURE__*/_react["default"].createElement(_carbonComponentsReact.Form, (0, _extends2["default"])({
    noValidate: true
  }, props, {
    className: (0, _clsx["default"])(form, className)
  }), children);
};

exports.Form = Form;
Form.propTypes = {
  children: _propTypes["default"].oneOfType([_propTypes["default"].arrayOf(_propTypes["default"].node), _propTypes["default"].node]),
  className: _propTypes["default"].string
};

var Header = function Header(props) {
  var _useStyles3 = useStyles(),
      header = _useStyles3.header;

  return /*#__PURE__*/_react["default"].createElement("div", (0, _extends2["default"])({
    className: header
  }, props));
};

exports.Header = Header;

var WrappedFormTemplate = function WrappedFormTemplate(props) {
  return /*#__PURE__*/_react["default"].createElement(_formTemplate["default"], (0, _extends2["default"])({
    FormWrapper: Form,
    Button: Button,
    ButtonGroup: ButtonGroup,
    Title: Title,
    Description: Description,
    buttonOrder: ['submit', 'reset', 'cancel'],
    Header: Header
  }, props));
};

var _default = WrappedFormTemplate;
exports["default"] = _default;