"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _useFieldApi2 = _interopRequireDefault(require("@data-driven-forms/react-form-renderer/use-field-api"));

var _carbonComponentsReact = require("carbon-components-react");

var _prepareProps = _interopRequireDefault(require("../prepare-props"));

var _helperTextBlock = _interopRequireDefault(require("../helper-text-block/helper-text-block"));

var _excluded = ["input", "meta", "isRequired", "validateOnMount", "helperText", "WrapperProps"];

var Slider = function Slider(props) {
  var _useFieldApi = (0, _useFieldApi2["default"])((0, _prepareProps["default"])(props)),
      input = _useFieldApi.input,
      meta = _useFieldApi.meta,
      isRequired = _useFieldApi.isRequired,
      validateOnMount = _useFieldApi.validateOnMount,
      helperText = _useFieldApi.helperText,
      WrapperProps = _useFieldApi.WrapperProps,
      rest = (0, _objectWithoutProperties2["default"])(_useFieldApi, _excluded);

  var invalid = (meta.touched || validateOnMount) && (meta.error || meta.submitError);
  var warnText = (meta.touched || validateOnMount) && meta.warning;
  return /*#__PURE__*/_react["default"].createElement("div", WrapperProps, /*#__PURE__*/_react["default"].createElement(_carbonComponentsReact.Slider, (0, _extends2["default"])({}, input, {
    value: Number(input.value) || 0,
    key: input.name,
    id: input.name,
    invalid: Boolean(invalid),
    min: 0,
    max: 100,
    required: isRequired
  }, rest)), /*#__PURE__*/_react["default"].createElement(_helperTextBlock["default"], {
    helperText: helperText,
    errorText: invalid,
    warnText: warnText
  }));
};

Slider.propTypes = {
  isDisabled: _propTypes["default"].bool,
  isRequired: _propTypes["default"].bool,
  label: _propTypes["default"].node,
  labelText: _propTypes["default"].node,
  description: _propTypes["default"].node,
  WrapperProps: _propTypes["default"].object
};
var _default = Slider;
exports["default"] = _default;