"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _useFieldApi2 = _interopRequireDefault(require("@data-driven-forms/react-form-renderer/use-field-api"));

var _carbonComponentsReact = require("carbon-components-react");

var _prepareProps = _interopRequireDefault(require("../prepare-props"));

var _helperTextBlock = _interopRequireDefault(require("../helper-text-block/helper-text-block"));

var _excluded = ["input", "meta", "onText", "offText", "validateOnMount", "helperText", "WrapperProps"],
    _excluded2 = ["checked"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

var Switch = function Switch(props) {
  var _useFieldApi = (0, _useFieldApi2["default"])(_objectSpread(_objectSpread({}, (0, _prepareProps["default"])(props)), {}, {
    type: 'checkbox'
  })),
      input = _useFieldApi.input,
      meta = _useFieldApi.meta,
      onText = _useFieldApi.onText,
      offText = _useFieldApi.offText,
      validateOnMount = _useFieldApi.validateOnMount,
      helperText = _useFieldApi.helperText,
      WrapperProps = _useFieldApi.WrapperProps,
      rest = (0, _objectWithoutProperties2["default"])(_useFieldApi, _excluded);

  var invalid = (meta.touched || validateOnMount) && (meta.error || meta.submitError);
  var warnText = (meta.touched || validateOnMount) && meta.warning;
  var checked = input.checked,
      inputRest = (0, _objectWithoutProperties2["default"])(input, _excluded2);
  return /*#__PURE__*/_react["default"].createElement("div", WrapperProps, /*#__PURE__*/_react["default"].createElement(_carbonComponentsReact.Toggle, (0, _extends2["default"])({}, inputRest, {
    toggled: checked,
    key: input.name,
    id: input.name,
    labelA: offText,
    labelB: onText
  }, rest)), /*#__PURE__*/_react["default"].createElement(_helperTextBlock["default"], {
    helperText: helperText,
    errorText: invalid,
    warnText: warnText
  }));
};

Switch.propTypes = {
  isDisabled: _propTypes["default"].bool,
  isReadOnly: _propTypes["default"].bool,
  isRequired: _propTypes["default"].bool,
  label: _propTypes["default"].node,
  labelText: _propTypes["default"].node,
  description: _propTypes["default"].node,
  WrapperProps: _propTypes["default"].object
};
var _default = Switch;
exports["default"] = _default;