"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _useFieldApi2 = _interopRequireDefault(require("@data-driven-forms/react-form-renderer/use-field-api"));

var _prepareProps = _interopRequireDefault(require("../prepare-props"));

var _timePickerBase = _interopRequireDefault(require("../time-picker-base"));

var _excluded = ["input", "meta", "twelveHoursFormat", "timezones", "validateOnMount", "helperText", "WrapperProps", "useStringFormat"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var TimePickerString = function TimePickerString(props) {
  var _useFieldApi = (0, _useFieldApi2["default"])((0, _prepareProps["default"])(props)),
      input = _useFieldApi.input,
      meta = _useFieldApi.meta,
      twelveHoursFormat = _useFieldApi.twelveHoursFormat,
      timezones = _useFieldApi.timezones,
      validateOnMount = _useFieldApi.validateOnMount,
      helperText = _useFieldApi.helperText,
      WrapperProps = _useFieldApi.WrapperProps,
      useStringFormat = _useFieldApi.useStringFormat,
      rest = (0, _objectWithoutProperties2["default"])(_useFieldApi, _excluded);

  var _useState = (0, _react.useState)(function () {
    var _input$value$match, _timezones$;

    return timezones ? ((_input$value$match = input.value.match(/ \w+$/)) === null || _input$value$match === void 0 ? void 0 : _input$value$match[0].trim()) || ((_timezones$ = timezones[0]) === null || _timezones$ === void 0 ? void 0 : _timezones$.value) : '';
  }),
      _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
      timezone = _useState2[0],
      selectTimezone = _useState2[1];

  var _useState3 = (0, _react.useState)(function () {
    var _input$value$match2;

    return ((_input$value$match2 = input.value.match(/ \w+ /)) === null || _input$value$match2 === void 0 ? void 0 : _input$value$match2[0].trim()) || 'AM';
  }),
      _useState4 = (0, _slicedToArray2["default"])(_useState3, 2),
      format = _useState4[0],
      selectFormat = _useState4[1];

  var isMounted = (0, _react.useRef)(false);
  var invalid = (meta.touched || validateOnMount) && (meta.error || meta.submitError);
  var warnText = (meta.touched || validateOnMount) && meta.warning;
  var finalValue = input.value.replace(/ .*/, '');

  var enhancedOnChange = function enhancedOnChange(value) {
    return input.onChange("".concat(value, " ").concat(twelveHoursFormat ? format : '', " ").concat(timezones ? timezone : '').replace(/ {2}/, ' ').trim());
  };

  (0, _react.useEffect)(function () {
    if (isMounted.current === true) {
      enhancedOnChange(finalValue);
    } else {
      isMounted.current = true;
    }
  }, [timezone, format]);
  return /*#__PURE__*/_react["default"].createElement(_timePickerBase["default"], (0, _extends2["default"])({
    WrapperProps: WrapperProps,
    input: input,
    enhancedOnChange: enhancedOnChange,
    finalValue: finalValue,
    invalid: invalid,
    twelveHoursFormat: twelveHoursFormat,
    timezones: timezones,
    helperText: helperText,
    warnText: warnText,
    selectFormat: selectFormat,
    selectTimezone: selectTimezone,
    format: format,
    timezone: timezone
  }, rest));
};

TimePickerString.propTypes = {
  isDisabled: _propTypes["default"].bool,
  isReadOnly: _propTypes["default"].bool,
  isRequired: _propTypes["default"].bool,
  label: _propTypes["default"].node,
  labelText: _propTypes["default"].node,
  description: _propTypes["default"].node,
  twelveHoursFormat: _propTypes["default"].bool,
  timezones: _propTypes["default"].arrayOf(_propTypes["default"].shape({
    value: _propTypes["default"].string.isRequired,
    label: _propTypes["default"].node.isRequired,
    showAs: _propTypes["default"].string
  })),
  WrapperProps: _propTypes["default"].object,
  useStringFormat: _propTypes["default"].bool
};
var _default = TimePickerString;
exports["default"] = _default;